#ifndef MYOPERATORS_HPP
#define MYOPERATORS_HPP
    #ifndef INCLUDED_BOOST_OPERATORS
    	#include <boost/operators.hpp>
		#define INCLUDED_BOOST_OPERATORS
	#endif
    #ifndef INCLUDED_BOOST_MPL_BOOL
		#include <boost/mpl/bool.hpp>
		#define INCLUDED_BOOST_MPL_BOOL
	#endif

	#ifndef INCLUDED_BOOST_MPL_OR
		#include <boost/mpl/or.hpp>
		#define INCLUDED_BOOST_MPL_OR
	#endif

	namespace algocpw
	{
		template <class T, class U>
		char (& is_op_test(boost::operators<T, U> const&) )[2];

		template <class T>
		char is_op_test(T const&);

		template<class T>
		T const& make();

		template <class T>
		struct is_operators
		 : boost::mpl::bool_<(sizeof(is_op_test(make<T>())) == 2)>
		{};
	}

#endif
